'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _graphqlServerKoa = require('graphql-server-koa');

var _Middleware = require('./Middleware');

var _Middleware2 = _interopRequireDefault(_Middleware);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

class ApolloGraphQL extends _react2.default.Component {

  constructor(props, context) {
    super(props, context);

    const { methods } = props;

    this.allowedMethods = Array.isArray(methods) ? methods : [methods];
    this.allowedMethods = this.allowedMethods.map(method => method.toUpperCase());
  }

  render() {
    var _this = this;

    const { options, path, schema } = this.props;

    return _react2.default.createElement(_Middleware2.default, {
      use: (() => {
        var _ref = _asyncToGenerator(function* (ctx, { finish, skip }) {
          if (path !== ctx.path) {
            skip();
          }

          if (!_this.allowedMethods.includes(ctx.method)) {
            ctx.status = 405;

            finish();
          }

          const opts = yield options(ctx);

          return (0, _graphqlServerKoa.graphqlKoa)(Object.assign({}, opts, { schema }))(ctx, function () {});
        });

        return function (_x, _x2) {
          return _ref.apply(this, arguments);
        };
      })()
    });
  }
}
exports.default = ApolloGraphQL;
ApolloGraphQL.defaultProps = {
  methods: ['GET', 'POST'],
  options: () => ({}),
  path: '/graphql'
};
module.exports = exports['default'];