'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _graphqlServerKoa = require('graphql-server-koa');

var _Middleware = require('./Middleware');

var _Middleware2 = _interopRequireDefault(_Middleware);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

class GraphiQL extends _react2.default.Component {

  render() {
    const { endpointURL, path } = this.props;

    return _react2.default.createElement(_Middleware2.default, {
      use: (() => {
        var _ref = _asyncToGenerator(function* (ctx, { finish, skip }) {
          if (ctx.path !== path) {
            skip();
          }

          if (ctx.method !== 'GET') {
            ctx.status = 405;

            finish();
          }

          yield (0, _graphqlServerKoa.graphiqlKoa)({ endpointURL })(ctx, function () {});

          // do not call next middleware functions
          finish();
        });

        return function (_x, _x2) {
          return _ref.apply(this, arguments);
        };
      })()
    });
  }
}
exports.default = GraphiQL;
GraphiQL.defaultProps = {
  endpointURL: '/graphql',
  path: '/graphiql'
};
module.exports = exports['default'];