'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _koaCompose = require('koa-compose');

var _koaCompose2 = _interopRequireDefault(_koaCompose);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _FinishMiddlewareError = require('./FinishMiddlewareError');

var _FinishMiddlewareError2 = _interopRequireDefault(_FinishMiddlewareError);

var _SkipToNextMiddlewareError = require('./SkipToNextMiddlewareError');

var _SkipToNextMiddlewareError2 = _interopRequireDefault(_SkipToNextMiddlewareError);

var _Server = require('./Server');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

class Middleware extends _react2.default.Component {

  constructor(props, context) {
    var _this;

    _this = super(props, context);

    this.middlewares = [];

    this.getChildContext = () => ({
      use: middleware => this.middlewares.push(middleware),
      server: this.context.server
    });

    this.context.use((() => {
      var _ref = _asyncToGenerator(function* (ctx, next) {
        try {
          let middlewaresCalled = false;
          const middlewares = (0, _koaCompose2.default)(_this.middlewares);

          yield props.use(ctx, {
            nested() {
              return _asyncToGenerator(function* () {
                middlewaresCalled = true;

                return middlewares(ctx);
              })();
            },
            finish() {
              throw new _FinishMiddlewareError2.default();
            },
            skip() {
              throw new _SkipToNextMiddlewareError2.default();
            }
          });

          // call nested middlewares automatically
          if (!middlewaresCalled) {
            yield middlewares(ctx);
          }

          // proceed to next middleware
          return yield next();
        } catch (e) {
          // if is skip error, then just work normally but skip to next middleware
          // if is finish error, then just return but don't call next middleware
          // otherwise just throw so error handler can catch it
          if (e instanceof _SkipToNextMiddlewareError2.default) {
            return yield next();
          } else if (e instanceof _FinishMiddlewareError2.default) {
            return;
          }

          throw e;
        }
      });

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    })());
  }

  render() {
    return _react2.default.createElement(
      'div',
      null,
      this.props.children
    );
  }
}
exports.default = Middleware;
Middleware.childContextTypes = _Server.serverContextType;
Middleware.contextTypes = _Server.serverContextType;
module.exports = exports['default'];