'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.serverContextType = undefined;

var _koa = require('koa');

var _koa2 = _interopRequireDefault(_koa);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _http = require('http');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// eslint-disable-next-line no-unused-vars
const serverContextType = exports.serverContextType = {
  use: _propTypes2.default.func.isRequired,
  server: _propTypes2.default.instanceOf(_koa2.default).isRequired
};

class Server extends _react2.default.Component {

  constructor(props, context) {
    super(props, context);

    this.getChildContext = () => ({
      use: middleware => this.app.use(middleware),
      server: this.app
    });

    this.app = new _koa2.default();

    this.props.context.app = this.app;
    this.props.context.listen = () => this.app.listen(this.props.port);
  }

  render() {
    return _react2.default.createElement(
      'div',
      null,
      this.props.children
    );
  }
}
exports.default = Server;
Server.defaultProps = {
  context: {}
};
Server.childContextTypes = serverContextType;