'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = serve;

var _koa = require('koa');

var _koa2 = _interopRequireDefault(_koa);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _http = require('http');

var _server = require('react-dom/server');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class ExtendedServer extends _http.Server {

  constructor(listen) {
    super();

    this.overriddenListener = listen;
  }

  listen() {
    return this.overriddenListener();
  }
}

function serve(server, listenAutomatically = true) {
  // flow hack, app and listen will be assigned using
  const context = {};

  (0, _server.renderToString)(_react2.default.cloneElement(server, { context }));

  if (listenAutomatically === true) {
    const srv = context.listen();

    srv.app = context.app;

    return srv;
  }

  const srv = new ExtendedServer(context.listen);

  srv.app = context.app;

  return srv;
}
module.exports = exports['default'];