'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = ClientSideRender;

var _spust = require('spust');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _RenderApp = require('../RenderApp');

var _RenderApp2 = _interopRequireDefault(_RenderApp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createRenderer(props) {
  let assets;
  let scripts = [];
  let stylesheets = [];

  return ctx => {
    // load assets everytime during development mode
    if (assets == null || process.env.NODE_ENV !== 'production') {
      assets = (0, _spust.assets)();
      scripts = assets.js.map(src => ({ src }));
      stylesheets = assets.css.map(href => ({ href }));
    }

    return {
      containerId: props.containerId,
      head: {
        title: props.title
      },
      lang: props.lang,
      scripts,
      stylesheets
    };
  };
}

function ClientSideRender(props) {
  return _react2.default.createElement(_RenderApp2.default, { render: createRenderer(props) });
}
module.exports = exports['default'];